{

  Written by

                   Dennis Passmore
            EMail: Compuserve: 71640,2464
       http://www.Dennis_Passmore@usgroup.com

  This example project although intended for Delphi 2+ can
  be adapted to Delphi 1.0 by deleting the TStatusbar code.

  02/08/1997
  Donated to public domain to help others learn by example.

}

unit tzipdemu;

interface

uses
{$ifdef win32} Windows, ComCtrls, {$else} Wintypes, Winprocs, {$endif}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Grids, Menus, TZReader, Buttons, ExtCtrls;

type
  CompareFunc = function (x, y: integer;var S): Integer of object;
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    OpenDialog1: TOpenDialog;
    ZipFileReader1: TZipFileReader;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Open1: TMenuItem;
    StatusBar1: TStatusBar;
    Setup1: TMenuItem;
    Font1: TMenuItem;
    Color1: TMenuItem;
    View1: TMenuItem;
    byName1: TMenuItem;
    byCompSize1: TMenuItem;
    byOrigSize1: TMenuItem;
    byDateTime1: TMenuItem;
    byPath1: TMenuItem;
    N2: TMenuItem;
    byAscending1: TMenuItem;
    byDescending1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure ZipFileReader1ReadFile(ZipDirRec: ZipFile);
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; lCol, lRow: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure StatusBar1Resize(Sender: TObject);
    procedure bySortItemClick(Sender: TObject);
    procedure bySortOrderClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    fColumn: integer;
    fCompareFunc: CompareFunc;
    SBA: array[0..4] of TSpeedButton;
    procedure Open_the_ZIP_File(const filename: string);
    function  CompareCellTxt(x, y: integer; var S): Integer;
    function  CompareLongInt(x, y: integer; var s): Integer;
    procedure QuickSort(L, R: Integer);
    procedure SortTheGrid;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function MinW(x, y: longint): longint;
begin
  if x < y then result := x else result := y;
end;

function MaxW(x, y: longint): longint;
begin
  if x > y then result := x else result := y;
end;

procedure TForm1.Open_the_ZIP_File(const filename: string);
var
  x, y: integer;
begin
  screen.cursor := crHourGlass;
  application.processmessages;
  with StringGrid1 do
  begin
    RowCount := 0;
    for x := 0 to ColCount -1 do
      Cols[x].BeginUpdate;
    ZipFileReader1.FileName := FileName;
    if RowCount>1 then
      RowCount := RowCount - 1;
    for x := 0 to RowCount - 1 do
    begin
      y := canvas.textwidth(cells[0, x]) + 10;
      if (y > ColWidths[0]) then
        ColWidths[0] := y;
    end;
    for x := 0 to RowCount - 1 do
    begin
      y := canvas.textwidth(cells[4, x]) + 10;
      if (y > ColWidths[4]) then
        ColWidths[4] := y;
    end;
    if SBA[0].width <> ColWidths[0] then
       SBA[0].width := ColWidths[0];
       SBA[1].left  := SBA[0].left + SBA[0].width + 1;
       SBA[2].left  := SBA[1].left + SBA[1].width + 1;
       SBA[3].left  := SBA[2].left + SBA[2].width + 1;
       SBA[4].left  := SBA[3].left + SBA[3].width + 1;
    if SBA[4].width <> ColWidths[4] then
       SBA[4].width := ColWidths[4];
    for x := 0 to ColCount -1 do
      Cols[x].EndUpdate;
  end;

  x := 0;
  for y := 0 to 4 do
    x := x + StatusBar1.panels[y].width;
  StatusBar1.panels[1].text := Inttostr(ZipFileReader1.FileCount);
  StatusBar1.panels[3].text := Inttostr(ZipFileReader1.FileSize);
  StatusBar1.panels[5].text := MinimizeName(ZipFileReader1.Filename,
                                        StatusBar1.Canvas, ClientWidth-x-30);
  SortTheGrid;
  screen.cursor := crDefault;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SBA[0] := SpeedButton1;
  SBA[1] := SpeedButton2;
  SBA[2] := SpeedButton3;
  SBA[3] := SpeedButton4;
  SBA[4] := SpeedButton5;
  SBA[0].Font.color := clRed;
  if paramcount>0 then
    Open_the_ZIP_File(ExpandFileName(paramstr(1)));
end;

procedure TForm1.ZipFileReader1ReadFile(ZipDirRec: ZipFile);
var
  p, s: shortstring;
begin
  with ZipDirRec, StringGrid1 do
  begin
    s := FileName;
    p := ' ';
    while (pos('\',s)>0) do
     begin
      inc(p[0]);
      p[length(p)] := s[1];
      system.delete(s,1,1);
     end;

    if (s<>'') then
      begin
        Cells  [0,RowCount-1] := s;
        Cells  [1,RowCount-1] := Inttostr(CompressedSize);
        Objects[1,RowCount-1] := pointer(CompressedSize);
        Cells  [2,RowCount-1] := Inttostr(UncompressedSize);
        Objects[2,RowCount-1] := pointer(UncompressedSize);
        Cells  [3,RowCount-1] := FormatDateTime('ddddd - t',
                                             FileDateToDateTime(DateTime));
        Objects[3,RowCount-1] := pointer(DateTime);
        Cells  [4,RowCount-1] := p;
        RowCount := RowCount + 1;
      end;
  end;
  application.processmessages;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    DefaultExt := '.ZIP';
    Filter := 'Zip files (*.zip)|*.ZIP|SFX Files (*.exe)'+
                                              '|*.EXE|All files (*.*)|*.*';
    options := [ofFileMustExist];
    if execute then
      Open_the_ZIP_File(FileName);
  end;
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; lCol, lRow: Longint;
  Rect: TRect; State: TGridDrawState);
var
  lRect, rRect: TRect;
begin
with (Sender as TStringGrid) do
 with Canvas do
  begin
    Brush := Brush;
    Font := Font;
    if (gdSelected in State)
     and (Sender = ActiveControl) then
      begin
        Brush.Color := clHighlight;
        Font.Color  := clHighlightText;
      end
    else
      if (gdFixed in State) then
        Brush.Color := StringGrid1.FixedColor
      else
        Brush.Color := StringGrid1.Color;
    FillRect(Rect);
    SetBkMode(Handle, TRANSPARENT);
    if ((lCol>0)and(lCol<4)) then
      begin
        SetTextAlign(Handle, TA_RIGHT);
        if (lCol=3) then
          begin
            lRect := Rect;
            lRect.Right := lRect.Left + ((Rect.Right - Rect.Left) div 2);
            rRect := Rect;
            rRect.Left  := lRect.Right;
            TextOut(lRect.Right-6, lRect.Top+2,
                copy(Cells[lCol, lRow], 1, pos('-',Cells[lCol, lRow])-2));
            TextOut(rRect.Right-3, rRect.Top+2,
                copy(Cells[lCol, lRow], pos('-',Cells[lCol, lRow])+2, 8));
          end
        else
          TextOut(Rect.Right-4, Rect.Top+2, Cells[lCol, lRow]);
      end
    else
      begin
        SetTextAlign(Handle, TA_LEFT);
        TextOut(Rect.Left+4, Rect.Top+2, Cells[lCol, lRow]);
      end;
  end;
end;

procedure TForm1.StatusBar1Resize(Sender: TObject);
var
  x, y: integer;
begin
  x := 0;
  for y := 0 to 4 do
    x := x + StatusBar1.panels[y].width;
  with StatusBar1, ZipFileReader1 do
    Panels[5].text := MinimizeName(Filename, Canvas, ClientWidth-x-40);
end;

function TForm1.CompareCellTxt(x, y: integer; var S): Integer;
type Sptr = ^ShortString;
var
  i: integer;
  s1: shortstring;
begin
  s1 := StringGrid1.Cells[x,y];
  if fColumn=4 then
    s1 := s1 + StringGrid1.Cells[0,y];
  i := MinW(Length(Sptr(S)^),length(s1));
  if copy(s1,1,i) > copy(Sptr(S)^,1,i) then
    result := 1
  else
    if copy(s1,1,i) = copy(Sptr(S)^,1,i) then
      result := 0
    else
      result := -1;
  if not(byAscending1.Checked) then Result := Result * -1;
end;

function TForm1.CompareLongInt(x, y: integer; var s): Integer;
begin
  if longint(StringGrid1.Objects[x,y]) > longint(S) then
    Result := 1
  else
    if longint(StringGrid1.Objects[x,y]) = longint(S) then
      Result := 0
    else
      Result := -1;
  if not(byAscending1.Checked) then Result := Result * -1;
end;

procedure TForm1.QuickSort(L, R: Integer);
var
  pivot: integer;
  C, I, J: Integer;
  P1: Pointer;
  S2: ShortString;
begin
 with StringGrid1 do
  begin
   I := L;
   J := R;
   pivot := (L + R) shr 1;
   S2 := Cells[fColumn,pivot];
   if fColumn=4 then
     S2 := S2 + Cells[0,pivot];
   if (fColumn>=1) and (fColumn<=3) then
     P1 := Objects[fColumn,pivot]
   else
     P1 := @S2;
   repeat
     while (fCompareFunc(fColumn, I, P1) < 0) do Inc(I);
     while (fCompareFunc(fColumn, J, P1) > 0) do Dec(J);
     if I <= J then
     begin
       for C := 0 to ColCount-1 do
         Cols[C].Exchange(I,J);
       Inc(I);
       Dec(J);
     end;
   until I > J;
  end;
  if L < J then QuickSort(L, J);
  if I < R then QuickSort(I, R);
end;

procedure TForm1.SortTheGrid;
var
  i: integer;
begin
  if (fColumn>=1) and (fColumn<=3) then
    fCompareFunc := CompareLongint
  else
    fCompareFunc := CompareCellTxt;
  with StringGrid1 do
  begin
    for i := 0 to ColCount-1 do
      Cols[i].BeginUpdate;
    RowCount := RowCount + 1;
    QuickSort(0,RowCount - 2);
    RowCount := RowCount - 1;
    for i := 0 to ColCount-1 do
      Cols[i].EndUpdate;
  end;
end;

procedure TForm1.bySortItemClick(Sender: TObject);
var
  i: integer;
begin
  byName1.OnClick     := nil;
  byCompSize1.OnClick := nil;
  byOrigSize1.OnClick := nil;
  byDateTime1.OnClick := nil;
  byPath1.OnClick     := nil;
  byName1.checked     := false;
  byCompSize1.checked := false;
  byOrigSize1.checked := false;
  byDateTime1.checked := false;
  byPath1.checked     := false;
  for i := 0 to 4 do
    SBA[i].font.color := clBlack;
  if sender = byName1 then
    fColumn := 0
  else
  if sender = byCompSize1 then
    fColumn := 1
  else
  if sender = byOrigSize1 then
    fColumn := 2
  else
  if sender = byDateTime1 then
    fColumn := 3
  else
    fColumn := 4;
  SBA[fColumn].font.color := clRed;
  TmenuItem(Sender).Checked := true;
  byName1.OnClick     := bySortItemClick;
  byCompSize1.OnClick := bySortItemClick;
  byOrigSize1.OnClick := bySortItemClick;
  byDateTime1.OnClick := bySortItemClick;
  byPath1.OnClick     := bySortItemClick;
  SortTheGrid;
end;

procedure TForm1.bySortOrderClick(Sender: TObject);
begin
  byAscending1.OnClick := nil;
  byDescending1.OnClick := nil;
  byAscending1.Checked := false;
  byDescending1.Checked := false;
  if (sender = byAscending1) then
    byAscending1.Checked := true
  else
    byDescending1.Checked := true;
  byAscending1.OnClick := bySortOrderClick;
  byDescending1.OnClick := bySortOrderClick;
  SortTheGrid;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to 4 do
    SBA[i].font.color := clBlack;
  i := 0;
  while (i<4)
   and ((Sender as TSpeedButton)<>SBA[i]) do
    inc(i);
  with SBA[i] do
  begin
    font.color := clRed;
    down := false;
  end;
  if fColumn = i then
    begin
      if byAscending1.Checked then
        bySortOrderClick(byDescending1)
      else
        bySortOrderClick(byAscending1);
    end
  else
    begin
      fColumn := i;
      SortTheGrid;
    end;
end;

end.
